// mapfile.h
// module to store the contents of an executable's symbol table

#ifndef __MAPFILE_H
#define __MAPFILE_H

#include "str.h"      // string

class MapFile {
  struct Entry {
    void const *addr;     // start-address of the symbol
    string name;          // symbol's name
  };
  Entry *entries;         // array of entries
  int numEntries;         // length of 'entries'

public:
  MapFile(char const *fname);    // filename of map file
  ~MapFile();

  // return name of symbol containing 'addr'; if the address is
  // less than any symbol's start, returns NULL
  char const *map(void const *addr);
};

#endif // __MAPFILE_H

