// stackbot.cc
// code for stackbot.h

#include "stackbot.h"     // this module

void *stackBottom = 0;

void initStackBottom()
{
  // it's very typical for the stack to be started on an address
  // which is not just page-aligned, but aligned to some high
  // multiple of pages; if pages are typically 4k (0x1000), we
  // should be safe looking for the nearest address aligned to
  // a 16-page boundary (0x10000) (whether the stack grows up
  // or down)
  int dummy;
  unsigned temp = (((unsigned)&dummy + 0x8000) / 0x10000) * 0x10000;
    // it's critical that temp be declared 'unsigned', because we
    // want the division to round, say, 0xc0007fe0 to 0xc0000000
    // and not 0xc00010000

  stackBottom = (void*)temp;
}


// ----------- test code --------------------
#ifdef TEST_STACKBOT

#include <stdio.h>    // printf

int main()
{
  initStackBottom();
  printf("I think stack bottom is at %p\n", stackBottom);
  return 0;
}

#endif // TEST_STACKBOT


